package RDF::Simple::Statement;
use strict;
use CGI::Carp;
use Data::Dumper;
use vars qw( @ISA );

@ISA = qw( );  # Defined by constructor


sub model { $_[0]->{'model'} }

sub new
{
    my( $class, $model ) = @_;

    my $source = $model->{'source'}{'name'};
    my $source_mod  = "RDF::Source::".$source."::Statement";
    my $source_file = $source_mod.".pm";
    $source_file =~ s|::|/|g;

    eval {require $source_file} or die $@;
    push @ISA, $source_mod;
    my $self = 
    {
	'model' => $model,
    };
    bless ($self, $class);

#    die Dumper $self, \@ISA;

    $self->SUPER::init();
    return $self;
}

sub pred  { $_[0]->{'simple'}{'pred'} = $_[1] if defined $_[1]; $_[0]->{'simple'}{'pred'} }
sub subj  { $_[0]->{'simple'}{'subj'} = $_[1] if defined $_[1]; $_[0]->{'simple'}{'subj'} }
sub obj   { $_[0]->{'simple'}{'obj' } = $_[1] if defined $_[1]; $_[0]->{'simple'}{'obj' } }
sub fact  { $_[0]->{'simple'}{'fact'} = $_[1] if defined $_[1]; $_[0]->{'simple'}{'fact'} }
sub uri   { $_[0]->{'simple'}{'uri' } = $_[1] if defined $_[1]; $_[0]->{'simple'}{'uri' } }


1;




