#!/usr/bin/perl -w
use strict;
use CGI;
use Data::Dumper;
use Carp;
use Time::HiRes qw( time );
# use FindBin; use lib $FindBin::Bin; # Gives tainted data!
use lib '/home/jonas/perl/proj/rdf/schema_editor/devel';
use RDF::Schema::Model;
use vars qw( $q $rdf );

#print "Content-type: Text/html\n\n<h1>Temporary disabled</h1>\n";exit;

#
# Make a expires_date for the cache. Let this expires_date follow the user.
#
#

{
    $q = new CGI;
    print $q->header;
    
    $rdf = new RDF::Schema::Model('DBI', "dbi:Pg:dbname=rdf005");

    my $state = $q->param('state') || 'class_list';

#    eval
    {
	no strict;
	&{"a_$state"};
	1;
    }
#    or print "<plaintext>Error for $state: $@";
    exit;
}

sub a_back
{
    my $history = $q->param('history')
	|| confess "No history?!?";

#    warn "History: $history\n";
    
    my @history = split "\n", $history;
    my( $state, $uri ) = split " ", pop @history;

    $q->param('history', join "\n", @history);
    $q->param('state', $state );
    $q->param('uri', $uri ) if $uri;

    {
	no strict;
	&{"a_$state"};
	1;
    }
}


sub a_class_list
{
    print $q->start_html('Class list');
    print $q->h1('Class list');

    my $classes = $rdf->get_top_classes;


    print "<table>\n";
    foreach my $class ( @$classes )
    {
	my $desig = $class->desig;
	my $uri   = $q->escape( $class->uri );

	print "<tr><td><a href=\"rdf.cgi?state=inventory&uri=$uri&history=class_list\">$desig</a>\n";
    }
    print "</table>\n";

#    print "<p><a href=\"rdf.cgi?state=add_aboutEachPrefix&history=class_list\">Add aboutEachPrefix</a>\n";
    print $q->end_html;
}

sub a_inventory
{
    my $uri = $q->param('uri');
    my $res = $rdf->get_node_by_uri( $uri );

    if( $res->is_instance_of( $rdf->rdfs('Class') ) )
    {
	&class_inventory( $res );
    }
    else
    {
	&node_inventory( $res );
    }
}


sub class_inventory
{
    my( $class ) = @_;

    my $desig = $class->desig;
    print $q->start_html("Class inventory for $desig");
    print $q->h1("Class inventory for $desig");

    my $eclass_uri = $q->escape( $class->uri );

  PARENTS:
    {
	print $q->h2('Parents');
	print "<table>\n";
	my $parent_list = $class->get_objects( $rdf->rdfs('subClassOf') );
	foreach my $res ( @$parent_list )
	{
	    my $desig = $res->desig;
	    my $euri =  $q->escape( $res->uri );
	    
	    print "<tr><td><a href=\"rdf.cgi?";
	    print "state=inventory&uri=$euri&history=inventory+$eclass_uri\">$desig</a>\n";
	}
	print "</table>\n";
    }

  CHILDS:
    {
	print $q->h2('Childs');
	print "<table>\n";
	my $child_list = $class->get_subjects( $rdf->rdfs('subClassOf') );
	foreach my $res ( @$child_list )
	{
	    my $desig = $res->desig;
	    my $euri =  $q->escape( $res->uri );
	    
	    print "<tr><td><a href=\"rdf.cgi?";
	    print "state=inventory&uri=$euri&history=inventory+$eclass_uri\">$desig</a>\n";
	}
	print "</table>\n";
    }

  PROPERTIES:
    {
	print $q->h2('Properties');
	print "<table>\n";
	my $prop_list = $class->get_subjects( $rdf->rdfs('domain') );
	foreach my $res ( @$prop_list )
	{
	    my $propl =  $res->desig;
	    my $eprop =  $q->escape( $res->uri );
	    
	    print "<tr><td><a href=\"rdf.cgi?";
	    print "state=inventory&uri=$eprop&history=inventory+$eclass_uri\">$propl</a>\n";

	    my $range_obj = $res->get_objects( $rdf->rdfs('range') );
	    if( $range_obj->[0] )
	    {
		my $rangel = $range_obj->[0]->label || $range_obj->[0]->uri;
		my $erange = $q->escape( $range_obj->[0]->uri );
	    
		print "<td><a href=\"rdf.cgi?";
		print "state=inventory&uri=$erange&history=inventory+$eclass_uri\">$rangel</a>\n";
	    }

	}
	print "</table>\n";
	
	print "<p>Add a property  (not implemented)</p>\n";

	my $euri = $q->escape($class->uri);
	print "<p><a href=\"rdf.cgi?state=edit_form&uri=$euri\">Edit</a> |\n";
	my $ehistory = $q->escape( $q->param('history') ) ||"";
	print "<a href=\"rdf.cgi?state=delete_confirm&uri=$euri&";
	print "history=$ehistory\">Delete</a> $desig\n";
    }

  NODES:
    {
	print $q->h2('Nodes of this type');
	print "<table>\n";
	my $res_list = $rdf->get_nodes_of_type_nonrecursively( $class );
	
	foreach my $res ( @$res_list )
	{
	    my $desig = $res->desig;
	    my $euri =  $q->escape( $res->uri );
	    
	    print "<tr><td><a href=\"rdf.cgi?";
	    print "state=inventory&uri=$euri&history=inventory+$eclass_uri\">$desig</a>\n";
	}
	print "</table>\n";

	my $euri = $q->escape( $class->uri );
	my $ehistory = $q->escape( $q->param('history') )||"";
	print "<p><a href=\"rdf.cgi?state=add_form&class=$euri";
	print "&previous=inventory+$euri&history=$ehistory\">Add a new $desig</a></p>\n";
    }

    print &footer;
    print $q->end_html;
}

sub footer
{
    return("<hr>\n".
	   "<p><a href=\"rdf.cgi\">Home...</a>\n");
}

sub node_inventory
{
    my( $subj ) = @_;

    my $uri = $subj->uri;
    my $desig = $subj->desig;
    my $esubj_uri = $q->escape( $uri );

    print $q->start_html("Node inventory for $desig");
    print $q->h1("Node inventory for $desig");

  PROPERTIES:
    {
	print $q->h2('Properties');
	print "<table border>\n";
	my $stalist = $subj->get_arcs_by_subject;
	foreach my $sta ( @$stalist )
	{
	    my $pred_desig = $sta->pred->desig;
	    my $epred_uri = $q->escape( $sta->pred->uri );
	    print "<tr><td valign=top> ";
	    print "<a href=\"rdf.cgi?state=inventory&uri=$epred_uri";
	    print "&history=inventory+$esubj_uri\">$pred_desig</a> <td>";
	    if( $sta->obj->is_instance_of( $rdf->rdfs('Container') ) )
	    {
#	    print "<ul>";
		foreach my $obj ( @{ $sta->obj->get_membership_objects } )
		{
		    my $value = $obj->value;
		    if( $value )
		    {
			print $q->li($value);
		    }
		    else
		    {
			my $desig = $obj->desig;
			my $euri =  $q->escape( $obj->uri );
			print "<li><a href=\"rdf.cgi?history=inventory+$esubj_uri&";
			print "state=inventory&uri=$euri\">$desig</a>\n";
		    }
		}
#	    print "</ul>\n";
	    }
	    else
	    {
		my $value = $sta->obj->value;
		if( $value )
		{
		    print $q->escapeHTML(": $value\n");
		}
		else
		{
		    my $desig = $sta->obj->desig;
		    my $euri =  $q->escape( $sta->obj->uri );
		    print ": <a href=\"rdf.cgi?history=inventory+$esubj_uri&";
		    print "state=inventory&uri=$euri\">$desig</a>\n";
		}
	    }
	}
	print "</table>\n";

	my $euri = $q->escape($uri);
	print "<p><a href=\"rdf.cgi?state=edit_form&uri=$euri\">Edit</a> |\n";
	my $ehistory = $q->escape( $q->param('history') ) ||"";
	print "<a href=\"rdf.cgi?state=delete_confirm&uri=$euri";
	print "&history=$ehistory\">Delete</a> $desig\n";
    }

  REFERER:
    {
	print $q->h2('Referer');
	print "<table border>\n";
	my $stalist = $subj->get_arcs_by_object;
	foreach my $sta ( @$stalist )
	{
	    my $pred_uri = $sta->pred->uri;
	    my $value = $sta->subj->value;
	    print "<tr><td>";
	    if( $value )
	    {
		print "$value\n";
	    }
	    else
	    {
		my $uri =  $sta->subj->uri;
		my $euri =  $q->escape( $uri );
		print "<a href=\"rdf.cgi?history=inventory+$esubj_uri&";
		print "state=inventory&uri=$euri\">$uri</a>\n";
	    }
	    print "<td>: $pred_uri\n";
	}
	print "</table>\n";
    }
    print &footer;
    print $q->end_html;
}

sub new_history
{
    my( $here ) = @_;
    $here ||= "";

    my $history = $q->param('history') || "";
    my $previous = $q->param('previous');

    if( $history and $previous and $previous ne $here )
    {
	$history .= "\n$previous";
    }
    elsif( $previous and $previous ne $here )
    {
	$history = $previous;
    }
    return $history;
}

sub a_delete_confirm
{
    my $subj_uri = $q->param('uri');
    my $subj = $rdf->get_node_by_uri( $subj_uri );
    my $subj_desig = $subj->desig;

    print $q->start_html("Confirmation: Delete $subj_desig?");
    print $q->h1("Confirmation: Delete $subj_desig?");
    print $q->p('This will delete (the representation for) ',
		'the resource, its property statements, ',
		'and all statement objects not shared by any other statements.');

    my $euri = $q->escape( $subj_uri );

    my $ehistory = $q->escape( &new_history );
    print "<p align=center><a href=\"rdf.cgi?state=delete_cascade&uri=$euri";
    print "&history=$ehistory\">Delete</a>\n";
    print &footer;
    print $q->end_html;
    
}

sub a_delete_confirm_arc
{
    my $arc_uri = $q->param('uri');
    my $arc = $rdf->get_arc_by_uri( $arc_uri );
    my $harc_uri = $q->escapeHTML( $arc_uri );

    print $q->start_html("Confirmation: Delete arc $harc_uri?");
    print $q->h1("Confirmation: Delete arc $harc_uri?");
    print $q->p('This will delete (the representation for) ',
		'the arc ',
		'and all statement objects not shared by any other statements.');

    my $earc_uri = $q->escape( $arc_uri );

    my $ehistory = $q->escape( &new_history );
    print "<p align=center><a href=\"rdf.cgi?state=delete_cascade_arc&uri=$earc_uri";
    print "&history=$ehistory\">Delete</a>\n";
    print &footer;
    print $q->end_html;
    
}

sub a_delete_cascade_arc
{
    my $arc_uri = $q->param('uri');
    my $arc = $rdf->get_arc_by_uri( $arc_uri );
    $q->param( 'uri', $arc->obj->uri );
    $arc->delete;
    &delete_cascade;
}

sub delete_cascade
{
    my $subj_uri = $q->param('uri');
    my $subj = $rdf->get_node_by_uri( $subj_uri );
    my $subj_desig = $subj->desig;

    print $q->start_html("Results for cascade deletion of $subj_desig?");
    print $q->h1("Results for cascade deletion of $subj_desig?");

    print "<ul>\n";
    print &delete_recurse( $subj );
    print "</ul>\n";

    my $ehistory = $q->escape( $q->param('history') );
    print "<p><a href=\"rdf.cgi?state=back&history=$ehistory\">Done!</a>\n";

    print &footer;
    print $q->end_html;
}

sub delete_recurse
{
    my( $subj ) = @_;
    my $text = "";

    my $arcs = $subj->get_arcs_by_object;
    if( @$arcs )
    {
	$text .= "<li>Will not remove ".$subj->desig;
	$text .= "<br>referenced by \n";
	$text .= "<ol>\n";
	
	foreach my $arc ( @$arcs )
	{
	    my $euri = $q->escape( $arc->subj->uri );
	    my $etarget = $q->escape( $q->param('uri') );
	    my $desig = $arc->subj->desig;
	    my $ehistory = $q->escape( $q->param('history') );
	    $text .= "<li><a href=\"rdf.cgi?state=edit_form&uri=$euri";
	    $text .= "&previous=delete_cascade+$etarget&history=$ehistory\">$desig</a>\n";
	}
	$text .= "</ol>\n";
    }
    else
    {
	my $arcs = $subj->get_arcs_by_subject;

	$text .= "<ul>\n";
	foreach my $arc ( @$arcs )
	{
	    my $obj = $arc->obj;
	    my $pred = $arc->pred;
	    $arc->delete;
	    
	    next if $pred->uri eq $rdf->rdf('type')->uri; 
	    
	    my $hpred = $q->escapeHTML( $pred->desig );
	    $text .= "<li><em>$hpred</em>\n";
	    $text .= &delete_recurse( $obj );
	}
	$text .= "</ul>\n";
	$text .= "<li>Removed ".$subj->desig."\n";
	$subj->delete;
    }
    return $text;
}

sub a_add_form
{
    my $class_uri = $q->param('class');
    my $class = $rdf->get_node_by_uri( $class_uri );
    my $class_desig = $class->desig;

    my $hhistory = $q->escapeHTML( &new_history );

    print $q->start_html("Add a new object of type $class_desig");
    print $q->h1("Add a new object of type $class_desig");
    print $q->p('We have to first create the object. ', 
		'You will then be able to update it with more data.');

    print $q->p('Non of the fields has to be filled in. ',
		'An empty uri will prompt the program to generate a local uri.');
    print "<form method=post>\n";
    print "<table>\n";
    print "<tr><td>uri <td><input name=uri size=60>\n";
    print "<tr><td>label <td><input name=label>\n";
    print "<tr><td>comment <td><input name=comment size=60>\n";
    print "</table>\n";
    print "<input type=hidden name=state value=add_result>\n";
    print "<input type=hidden name=type value=\"$class_uri\">\n";
    print "<input type=hidden name=history value=\"$hhistory\">\n";

    print "<p><input type=submit>\n";
    print "</form>\n";
    print &footer;
    print $q->end_html;
}

sub a_add_result
{
    my $class_uri = $q->param('type') or die "no type";

    my $res_uri = $q->param('uri') || undef;
    if( $res_uri )
    {
	if( $rdf->node_exist_with_uri( $res_uri ) )
	{
	    print $q->start_html('Creation failed');
	    print $q->h1('Creation failed');
	    print $q->p("$res_uri already exists!");
	    print $q->end_html;
	    return undef;
	}
    }

    my $res = $rdf->add_node( $res_uri );
    $res_uri = $res->uri; # update with real value

    my $class = $rdf->get_node_by_uri( $class_uri );

    $rdf->add_arc( $rdf->rdf('type'), $res, $class );

    if( $q->param('label') )
    {
	my $label = $rdf->add_node( undef, $q->param('label') );
	$rdf->add_arc( $rdf->rdfs('label'), $res, $label );
    }

    if( $q->param('comment') )
    {
	my $comment = $rdf->add_node( undef, $q->param('comment') );
	$rdf->add_arc( $rdf->rdfs('comment'), $res, $comment );
    }

    $q->param('uri', $res_uri);
    $q->param('previous', "inventory ".$res_uri); 
    &a_edit_form;
}

sub a_edit_save
{
    my( @first, @last );
    foreach( $q->param )
    {
	next unless /^value .*? (\w+)/;
	if( $1 eq 'lit' or $1 eq 'obj' )
	{
	    push @first, $_;
	}
	else
	{
	    push @last, $_;
	}
    }
    
    my %new_arc; # $new_arc{$subj_uri}{$pred_uri} = $arc

    foreach my $key ( @first, @last )
    {
	next unless $key =~ /^value (.*?) (\w+) (\w+) (.*?) (.*)/;

	my $subj_uri = $1;
	my $action = $2; # arc | new
	my $type = $3;   # lit | obj | pred | lang | con
	my $uri = $4;    # arc_uri | pred_uri
	my $old = $5;

	next if defined $old and $q->param($key) eq $old;

	if( $action eq 'arc' )
	{
	    my $arc = $rdf->get_arc_by_uri( $uri );
	    my $node = $arc->obj;

	    if( $type eq 'lit' )
	    {
		if( $q->param($key) eq "" )
		{
		    $node->delete;
		    $arc->delete;
		}
		else
		{
		    $node->value( $q->param($key) );
		    $node->store;
		}
	    }
	    elsif( $type eq 'res' )
	    {
		if( $q->param($key) eq "" )
		{
		    $arc->delete;
		    # How do I delete the node?
		}
		else
		{
		    my $pred = $arc->pred;
		    my $subj = $arc->subj;

		    $arc->delete;
		    # How do I delete the node?

		    my $obj;
		    if( $rdf->node_exist_with_uri( $q->param($key) ) )
		    {
			$obj = $rdf->get_node_by_uri( $q->param($key) );
		    }
		    else
		    {
			$obj = $rdf->add_node( $q->param($key) );
		    }
		    $rdf->add_arc( $pred, $subj, $obj );
		}
	    }
	    elsif( $type eq 'obj' )
	    {
		if( $q->param($key) eq "" )
		{
		    $arc->delete;
		}
		else
		{
		    my $obj = $rdf->get_node_by_uri( $q->param($key) );
		    
		    $arc->obj( $obj );
		    $arc->store;
		}
	    }
	    elsif( $type eq 'pred' )
	    {
		$q->param($key) =~ /^(\d+)$/ or next; # Should give warning
		my $pred = $rdf->get_ContainerMembershipProperty( $1 );
		
		$arc->pred( $pred );
		$arc->store;
	    }
	    else
	    {
		die "Faulty key: $key";
	    }
	}
	elsif( $action eq 'new' )
	{
	    my $pred = $rdf->get_node_by_uri( $uri );
	    my $subj = $rdf->get_node_by_uri( $subj_uri );
	    if( $type eq 'lit' )
	    {
		my $obj = $rdf->add_node( undef, $q->param($key) );
		$new_arc{$subj_uri}{$uri} = $rdf->add_arc( $pred, $subj, $obj );
	    }
	    elsif( $type eq 'res' )
	    {
		my $obj;
		if( $rdf->node_exist_with_uri( $q->param($key) ) )
		{
		    $obj = $rdf->get_node_by_uri( $q->param($key) );
		}
		else
		{
		    $obj = $rdf->add_node( $q->param($key) );
		}
		$rdf->add_arc( $pred, $subj, $obj );
	    }
	    elsif( $type eq 'obj' )
	    {
		my $obj = $rdf->get_node_by_uri( $q->param($key) );
		$new_arc{$subj_uri}{$uri} = $rdf->add_arc( $pred, $subj, $obj );
	    }
	    elsif( $type eq 'pred' )
	    {
		$q->param($key) =~ /^(\d+)$/ or next; # Should give warning
		my $pred = $rdf->get_ContainerMembershipProperty( $1 );

		my $arc = $new_arc{$subj_uri}{$uri} or next;
		$arc->pred( $pred );
		$arc->store;
	    }
	    elsif( $type eq 'con' )
	    {
		my $node = $rdf->add_node;
		my $con = $rdf->get_node_by_uri( $q->param($key) );
		$rdf->add_arc( $pred, $subj, $node );
		$rdf->add_arc( $rdf->rdf('type'), $node, $con );
	    }
	    else
	    {
		die "Faulty key: $key";
	    }
	}
	else
	{
	    die "Faulty key: $key";
	}
    }
    
    my $next = $q->param('next');
#    warn "Next: $next\n";

    {
	no strict;
	&{"a_$next"};
	1;
    }
}

sub a_edit_form
{
    my $subj_uri = $q->param('uri');
    my $subj = $rdf->get_node_by_uri( $subj_uri );
    my $subj_desig = $subj->desig;

    $q->param('history') or $q->param('history', "inventory $subj_uri"); # default
    # add previous to history if previous ne this_place
    my $this_place = "edit_form $subj_uri";
    my $history = &new_history( $this_place );
    


    print $q->start_html("Edit node $subj_desig");
    print $q->h1("Edit node $subj_desig");
    print $q->p('Leve a field blank, to not add it as a property. ',
		'Empty a field to delete it.',
		'The + button will actualy submit any changes made.',
		'There will always be exactly one extra field per property.');

  PROPERTIES:
    {
	print "<form method=post action=\"rdf.cgi\" name=f>\n";
	print "<table border><tr><th>Property <th>Range <th>Value ";
	print "<th>Lang <th colspan=2>Add a new item <th>Comment\n";
	my @prop_list = sort by_class_uri values %{$subj->get_domain_properties};
	foreach my $entry ( @prop_list )
	{
	    my $prop = $entry->{'prop'};
	    my $class = $entry->{'class'};

	    my $prop_desig =  $prop->desig;
	    my $eprop_uri =  $q->escape( $prop->uri );
	    
	    print "<tr><td><a href=\"rdf.cgi?";
	    print "state=inventory&uri=$eprop_uri\">$prop_desig</a>\n";

	    if( my $range_list = $prop->get_objects( $rdf->rdfs('range') ) )
	    {
		my $range = $range_list->[0] || $rdf->rdfs('Resource');
		my $rangel = $range->label || $range->uri;
		my $erange = $q->escape( $range->uri );
		print "<td><a href=\"rdf.cgi?";
		print "state=inventory&uri=$erange\">$rangel</a>  ";
	
		&form_view_value( $subj, $prop, $range );
	    }
	    else
	    {
		print "<td><em>anything</em> ";
		print "<td colspan=4>Edit the property to specify the range\n";
	    }
	}
	print "</table>\n";
    }

    
    my $huri = $q->escapeHTML( $subj_uri );
    print "<input type=hidden name=uri value=\"$huri\">\n";
    print "<input type=hidden name=state value=\"edit_save\">\n";
    print "<input type=hidden name=next value=\"edit_form\">\n";

    my $hhistory = $q->escapeHTML( $history );
    my $hprevious = $q->escapeHTML( $this_place );
    print "<input type=hidden name=history value=\"$hhistory\">\n";
    print "<input type=hidden name=previous value=\"$hprevious\">\n";
    
    print "<p><input type=button value=\" Done! \" 
            onClick=\"document.f.next.value='back';document.f.submit()\"></p>\n";

    print "</form>\n";

    print &footer;
    print $q->end_html;
}

sub by_class_uri { $a->{'class'}->uri cmp $b->{'class'}->uri; }

sub form_view_value
{
    my( $subj, $prop, $range ) = @_;

    my $is_lit = $range->is_Class_or_subClassOf( $rdf->rdfs('Literal') );
    my $is_res = ( $range->uri eq $rdf->rdfs('Resource')->uri );
    
    my $row = 1;
    my $arcs = $subj->get_arcs_by_subject( $prop );
    foreach my $arc ( @$arcs )
    {
	if( $arc->obj->is_instance_of( $rdf->rdfs('Container') ) )
	{
	    print "<tr><td><td>" unless $row==1;
	    if( $is_lit )
	    {
		&form_value_lit_con( $arc->obj, $prop, $range, $arc );
	    }
	    elsif( $is_res )
	    {
		&form_value_res_con( $arc->obj, $prop, $range, $arc );
	    }
	    else
	    {
		&form_value_obj_con( $arc->obj, $prop, $range, $arc );
	    }
	    print "<td>";
	}
	else
	{
	    print "<tr><td><td>" unless $row==1;
	    if( $is_lit )
	    {
		&form_value_lit( $subj, $prop, $range, $arc );
	    }
	    elsif( $is_res )
	    {
		&form_value_res( $subj, $prop, $range, $arc );
	    }
	    else
	    {
		&form_value_obj( $subj, $prop, $range, $arc );
	    }
	    print "<td colspan=2>";
	}

	if( $row == 1 )
	{
	    my $rows = $#$arcs + 2; # No container support
	    print "<td rowspan=$rows>";
	    &form_view_comment( $prop );
	}
	print "\n";
	$row ++;
    }
  EMPTY:
    {
	print "<tr><td><td>" unless $row==1;
	if( $is_lit )
	{
	    &form_value_lit($subj, $prop, $range );
	}
	elsif( $is_res )
	{
	    &form_value_res($subj, $prop, $range );
	}
	else
	{
	    &form_value_obj($subj, $prop, $range );
	}

	print "<td><input type=submit value=\" + \">";

	my $containers = $rdf->get_subclasses_for( $rdf->rdfs('Container') );

	my $hsubj_uri = $q->escapeHTML( $subj->uri );
	my $hprop_uri = $q->escapeHTML( $prop->uri );
	print "<td><select name=\"value $hsubj_uri new con $hprop_uri \">";
	print "<option value=\"\">&nbsp;";
	foreach my $con ( @$containers )
	{
	    my $hcon_uri = $q->escapeHTML( $con->uri );
	    print "<option value=\"$hcon_uri\">".$con->desig;
	}
	print "</select>\n";

	if( $row == 1 )
	{
	    print "<td>";
	    &form_view_comment( $prop );
	}
    }
    print "\n";
}

sub form_value_lit
{
    my( $subj, $prop, $range, $arc ) = @_;

    my $hsubj_uri = $q->escapeHTML( $subj->uri );
    my( $name, $hvalue );
    if( $arc )
    {
	my $harc_uri = $q->escapeHTML( $arc->uri );
	$hvalue = $q->escapeHTML( $arc->obj->value );
	$name = "value $hsubj_uri arc lit $harc_uri $hvalue";
    }
    else
    {
	my $hprop_uri = $q->escapeHTML( $prop->uri );
	$name = "value $hsubj_uri new lit $hprop_uri "; #Last space must be there
	$hvalue = "";
    }

    print "<td><input size=40 name=\"$name\" value=\"$hvalue\"> ";
    print "<td><input size=5>";
}

sub form_value_res
{
    my( $subj, $prop, $range, $arc ) = @_;

    my $hsubj_uri = $q->escapeHTML( $subj->uri );
    my( $name, $hvalue );
    if( $arc )
    {
	my $harc_uri = $q->escapeHTML( $arc->uri );
	$hvalue = $q->escapeHTML( $arc->obj->uri );
	$name = "value $hsubj_uri arc res $harc_uri $hvalue";
    }
    else
    {
	my $hprop_uri = $q->escapeHTML( $prop->uri );
	$name = "value $hsubj_uri new res $hprop_uri "; #Last space must be there
	$hvalue = "";
    }

    print "<td><input size=40 name=\"$name\" value=\"$hvalue\"> ";
    print "<td><input type=button value=\"search\">";
}

sub form_value_obj
{
    my( $subj, $prop, $range, $arc ) = @_;


#    warn $range->uri."\n";
   
    

    my $hsubj_uri = $q->escapeHTML( $subj->uri );
    my( $name, $hvalue );
    if( $arc )
    {
	my $harc_uri = $q->escapeHTML( $arc->uri );
	$hvalue = $q->escapeHTML( $arc->obj->uri );
	$name = "value $hsubj_uri arc obj $harc_uri $hvalue";
    }
    else
    {
	my $hprop_uri = $q->escapeHTML( $prop->uri );
	$name = "value $hsubj_uri new obj $hprop_uri "; #Last space must be there
	$hvalue = "";
    }

#	warn "\t".(time-$time)."\n";
#    my $time = time;

    print "<td><select name=\"$name\">\n";
    print "<option value=\"\">&nbsp;\n";
    my @subject_list = @{$rdf->get_nodes_of_type($range, {order => 'by_label'})};


#	warn "\t".(time-$time)."\n";

    foreach my $subj ( @subject_list )
    {
	my $hlabel = $q->escapeHTML( $subj->label||$subj->uri );
	my $huri = $q->escapeHTML( $subj->uri );

	print "<option value=\"$huri\" ";
	print "selected" if $subj->uri eq $hvalue;
	print ">$hlabel\n";
    }
    print "</select>\n";
    print "<td><input type=button value=\"new\">\n";

#	warn "\t".(time-$time)."\n";

}

sub form_value_lit_con
{
    my( $subj, $prop, $range, $arc ) = @_;

    my $harc_uri = $q->escapeHTML( $arc->uri );
    my $hsubj_uri = $q->escapeHTML( $subj->uri );
    my $con = $arc->obj;
    my $con_uri = $con->uri;
    my $hcon_uri = $q->escapeHTML( $con_uri );
    my $type = $con->get_objects( $rdf->rdf('type') )->[0];
    my $type_uri = $type->uri;

    print "<td align=right>$con_uri <td>$type_uri ";
#    print "<input type=hidden name=conuri value=\"$hcon_uri\"> ";
    print "<td><input type=button value=\" - \" ";
    print "onClick=\"document.f.next.value='delete_confirm_arc';";
    print "document.f.uri.value='$harc_uri';";
    print "document.f.submit()\">\n";

    my $arc_list = $con->get_membership_arcs;
    my $cnt = 1;
    foreach my $arc (  @$arc_list )
    {
	my $harc_uri = $q->escapeHTML( $arc->uri );
	my $new_prop = $rdf->get_ContainerMembershipProperty( $cnt );
	my $name = "value $hsubj_uri arc pred $harc_uri $cnt";
	print "<tr><td><td align=right>";
	print "<input size=4 name=\"$name\" value=\"$cnt\"> ";
	&form_value_lit( $subj, $new_prop, $range, $arc );
	$cnt++;
    }

    my $new_prop = $rdf->get_ContainerMembershipProperty( $cnt );
    my $hprop_uri = $q->escapeHTML( $new_prop->uri );
    my $name = "value $hsubj_uri new pred $hprop_uri $cnt";
    print "<tr><td><td align=right>";
    print "<input size=4 name=\"$name\" value=\"$cnt\"> ";
    &form_value_lit($subj, $new_prop, $range );
    print "<td><input type=submit value=\" + \">";
}


sub form_value_res_con
{
    my( $subj, $prop, $range, $arc ) = @_;

    my $harc_uri = $q->escapeHTML( $arc->uri );
    my $hsubj_uri = $q->escapeHTML( $subj->uri );
    my $con = $arc->obj;
    my $con_uri = $con->uri;
    my $hcon_uri = $q->escapeHTML( $con_uri );
    my $type = $con->get_objects( $rdf->rdf('type') )->[0];
    my $type_uri = $type->uri;

    print "<td align=right>$con_uri <td>$type_uri ";
#    print "<input type=hidden name=conuri value=\"$hcon_uri\"> ";
    print "<td><input type=button value=\" - \" ";
    print "onClick=\"document.f.next.value='delete_confirm_arc';";
    print "document.f.uri.value='$harc_uri';";
    print "document.f.submit()\">\n";

    my $arc_list = $con->get_membership_arcs;
    my $cnt = 1;
    foreach my $arc (  @$arc_list )
    {
	my $harc_uri = $q->escapeHTML( $arc->uri );
	my $new_prop = $rdf->get_ContainerMembershipProperty( $cnt );
	my $name = "value $hsubj_uri arc pred $harc_uri $cnt";
	print "<tr><td><td align=right>";
	print "<input size=4 name=\"$name\" value=\"$cnt\"> ";
	&form_value_res( $subj, $new_prop, $range, $arc );
	$cnt++;
    }

    my $new_prop = $rdf->get_ContainerMembershipProperty( $cnt );
    my $hprop_uri = $q->escapeHTML( $new_prop->uri );
    my $name = "value $hsubj_uri new pred $hprop_uri $cnt";
    print "<tr><td><td align=right>";
    print "<input size=4 name=\"$name\" value=\"$cnt\"> ";
    &form_value_res($subj, $new_prop, $range );
    print "<td><input type=submit value=\" + \">";
}


sub form_value_obj_con
{
    my( $subj, $prop, $range, $arc ) = @_;

    my $hsubj_uri = $q->escapeHTML( $subj->uri );
    my $con = $arc->obj;
    my $con_uri = $con->uri;
    my $hcon_uri = $q->escapeHTML( $con_uri );
    my $type = $con->get_objects( $rdf->rdf('type') )->[0];
    my $type_uri = $type->uri;

    print "<td align=right>$con_uri <td>$type_uri ";
    print "<td><input type=button value=\" - \" ";
    print "onClick=\"document.f.next.value='delete_confirm';";
    print "document.f.uri.value=document.f.conuri.value;";
    print "document.f.submit()\">\n";

    my $arc_list = $con->get_membership_arcs;
    my $cnt = 1;
    foreach my $arc (  @$arc_list )
    {
	my $harc_uri = $q->escapeHTML( $arc->uri );
	my $new_prop = $rdf->get_ContainerMembershipProperty( $cnt );
	my $name = "value $hsubj_uri arc pred $harc_uri $cnt";
	print "<tr><td><td align=right>";
	print "<input size=4 name=\"$name\"value=\"$cnt\"> ";
	&form_value_obj( $subj, $new_prop, $range, $arc );
	$cnt++;
    }

    my $new_prop = $rdf->get_ContainerMembershipProperty( $cnt );
    my $hprop_uri = $q->escapeHTML( $new_prop->uri );
    my $name = "value $hsubj_uri new pred $hprop_uri $cnt";
    print "<tr><td><td align=right>";
    print "<input size=4 name=\"$name\" value=\"$cnt\"> ";
    &form_value_obj($subj, $new_prop, $range );
    print "<td><input type=submit value=\" + \">";
}


# Time sucker!!!
#
#sub by_label { ($a->label||$a->uri) cmp ($b->label||$b->uri) }


sub form_view_comment
{
    my( $prop ) = @_;

    my $comment = $prop->get_objects( $rdf->rdfs('comment') )->[0];

    print $comment ? $comment->value : "";
}








